<script>
import Vue from "vue";

import { SlpButton, SlpTypography, SlpIcon } from "slippers-ui";
import NavCard from "../Common/nav-card.vue";

import ChevronIcon from "../../assets/chevron.vue";
import CloseIcon from "../../assets/close.vue";
import GitLabIcon from "../../assets/gitlab2.vue";
import TimeIsMoneyIcon from "../../assets/time-is-money.vue";
import PricingPlansIcon from "../../assets/pricing-plans.vue";
import NavDropdownFooter from "../Common/nav-dropdown-footer.vue";

export default Vue.extend({
  name: "SlpNavigationMobile",
  components: {
    ChevronIcon,
    CloseIcon,
    GitLabIcon,
    TimeIsMoneyIcon,
    PricingPlansIcon,
    SlpButton,
    SlpTypography,
    SlpIcon,
    NavDropdownFooter,
    NavCard,
  },
  props: {
    navigationData: {
      required: true,
      type: Object,
    },
    hideSalesButton: {
      required: true,
      type: Boolean,
    },
  },
  data() {
    return {
      activeTitle: "",
      navItems: this.navigationData.navItems,
      sectionIndex: -1,
      isDropdownOpen: false,
      logoUrl: this.navigationData.logo.fields.url.content[0].content[0].value,
    };
  },
  methods: {
    setActiveNavItem(index) {
      this.sectionIndex = index;
      this.activeTitle = this.navItems[index].title;
      this.isDropdownOpen = true;
    },
    back() {
      this.sectionIndex = -1;
      this.activeTitle = "";
      this.isDropdownOpen = false;
    },
  },
});
</script>

<template>
  <div class="be-nav-mobile-menu">
    <div :class="{ 'slp-mb-24': !isDropdownOpen }">
      <div>
        <!-- Top Logo Menu -->
        <div class="be-nav-mobile-menu-top_logo">
          <SlpButton
            variant="icon"
            :href="logoUrl"
            data-nav="logo"
            aria-label="Home"
            name="Home"
          >
            <GitLabIcon ariaId="tanukiHomeMobileMenu" />
          </SlpButton>
          <SlpButton
            variant="icon"
            @click.native="$emit('onClose')"
            aria-label="Close dropdown"
          >
            <CloseIcon fill="#171321" />
          </SlpButton>
        </div>
        <!-- Section Menu back button -->
        <div v-if="!(sectionIndex && sectionIndex === -1)" class="slp-flex">
          <div class="be-nav-mobile-menu-top_back">
            <SlpButton variant="ghost" @click.native="back()" name="Go Back">
              <ChevronIcon class="slp-mr-8" direction="left" />
              <SlpTypography variant="body1" tag="span"
                >{{ activeTitle }}
              </SlpTypography>
            </SlpButton>
          </div>
        </div>
      </div>
      <div>
        <!-- First Level Menu -->
        <div
          v-for="(item, index) in navItems"
          :key="item.text"
          class="slp-flex"
        >
          <SlpButton
            v-show="!isDropdownOpen"
            tag="li"
            variant="ghost"
            class="be-nav-mobile-menu-item"
            :href="item.categories ? '' : item.href"
            @click.native="item.categories ? setActiveNavItem(index) : ''"
            v-bind="item.headerGa"
            :name="item.text"
          >
            <SlpTypography tag="span" variant="body1">
              <span>{{ item.text }}</span>
            </SlpTypography>
            <ChevronIcon v-if="item.categories" direction="right" />
          </SlpButton>
        </div>
        <!-- Second Level Menu -->
        <div v-if="isDropdownOpen">
          <div
            v-if="
              !navItems[sectionIndex].layout ||
              navItems[sectionIndex].layout === 'Default' ||
              navItems[sectionIndex].layout === 'Solutions (Update)'
            "
          >
            <div
              v-for="(item, categoryIndex) in navItems[sectionIndex].categories"
              :key="item.title"
              class="slp-flex"
              :class="{
                'slp-mb-24':
                  categoryIndex ===
                  navItems[sectionIndex].categories.length - 1,
              }"
            >
              <div v-if="item.items.length" class="slp-ml-16 w-100">
                <SlpTypography
                  :tag="item.href ? 'a' : 'h5'"
                  variant="body2-bold"
                  :href="item.href"
                  style="display: block"
                  class="slp-color-accent-500 slp-ml-16 slp-mt-24 slp-mb-16"
                  >{{ item.title.replace(/<\/?[^>]+(>|$)/g, "") }}
                </SlpTypography>
                <div
                  v-for="subItem in item.items"
                  :key="subItem.text"
                  class="slp-flex"
                >
                  <SlpButton
                    tag="li"
                    variant="ghost"
                    class="be-nav-mobile-menu-item slp-ml-16"
                    v-bind="subItem.headerGa"
                    :name="subItem.text"
                    :href="subItem.href"
                  >
                    <SlpTypography tag="span" variant="body1">
                      {{ subItem.text }}
                    </SlpTypography>
                  </SlpButton>
                </div>
              </div>
              <SlpButton
                v-else
                tag="li"
                variant="ghost"
                class="be-nav-mobile-menu-item be-nav-mobile-menu-item--sub"
                v-bind="item.headerGa"
                :name="item.text"
                :href="item.href"
              >
                <SlpTypography tag="span" variant="body1">
                  {{ item.text || item.title.replace(/<\/?[^>]+(>|$)/g, "") }}
                </SlpTypography>
              </SlpButton>
            </div>
          </div>
          <div v-else>
            <NavCard
              v-for="category of navItems[sectionIndex].categories"
              :key="category.title"
              v-bind="category"
              disable-line-breaks
            />
            <NavDropdownFooter
              v-if="navItems[sectionIndex].footer"
              v-bind="navItems[sectionIndex].footer.fields"
            />
          </div>
          <SlpButton
            v-if="navItems[sectionIndex].bottomLink"
            class="slp-ml-32 slp-mb-16"
            variant="tertiary"
            :href="navItems[sectionIndex].bottomLink.href"
            v-bind="navItems[sectionIndex].bottomLink.headerGa"
          >
            {{ navItems[sectionIndex].bottomLink.text }}
            <SlpIcon
              class="slp-ml-8"
              name="chevron-lg-right"
              variant="product"
              alt="Chevron Right Icon"
            />
          </SlpButton>
          <NavDropdownFooter
            v-if="
              navItems[sectionIndex].layout === 'Solutions (Update)' &&
              navItems[sectionIndex].footer
            "
            v-bind="navItems[sectionIndex].footer.fields"
          />
          <!-- RESOURCES BOTTOM SECTION -->
          <a
            class="be-nav-mobile-menu__bottom-section"
            v-if="
              navItems[sectionIndex].primarySideSection &&
              !navItems[sectionIndex].secondarySideSection
            "
            :href="navItems[sectionIndex].primarySideSection.primaryLink.href"
            v-bind="
              navItems[sectionIndex].primarySideSection.primaryLink.headerGa
            "
          >
            <SlpTypography tag="span" variant="body2" class="slp-mb-8">
              {{ navItems[sectionIndex].primarySideSection.title }}
            </SlpTypography>
            <div class="be-nav-mobile-menu__image">
              <img
                v-if="navItems[sectionIndex].primarySideSection.image"
                :src="navItems[sectionIndex].primarySideSection.image.url"
                :alt="navItems[sectionIndex].primarySideSection.image.altText"
              />
            </div>
            <SlpTypography
              tag="p"
              variant="body1-bold"
              class="slp-mb-32 slp-mt-32"
            >
              {{ navItems[sectionIndex].primarySideSection.text }}
            </SlpTypography>
            <SlpButton
              v-if="navItems[sectionIndex].primarySideSection.primaryLink"
              class="be-nav-mobile-menu__side-link"
              variant="tertiary"
              :href="navItems[sectionIndex].primarySideSection.primaryLink.href"
              v-bind="
                navItems[sectionIndex].primarySideSection.primaryLink.headerGa
              "
            >
              {{ navItems[sectionIndex].primarySideSection.primaryLink.text }}
              <SlpIcon
                name="arrow-right"
                variant="product"
                alt="Chevron Right Icon"
              />
            </SlpButton>
          </a>
          <!-- SOLUTIONS BOTTOM SECTION -->
          <div
            v-if="
              navItems[sectionIndex].primarySideSection &&
              navItems[sectionIndex].secondarySideSection
            "
          >
            <a
              class="be-nav-mobile-menu__bottom-section"
              :href="navItems[sectionIndex].primarySideSection.primaryLink.href"
              v-bind="
                navItems[sectionIndex].primarySideSection.primaryLink.headerGa
              "
            >
              <div>
                <div class="be-nav-mobile-menu__icon">
                  <TimeIsMoneyIcon />
                </div>
                <SlpTypography tag="span" variant="body3-bold" class="slp-mb-8">
                  {{ navItems[sectionIndex].primarySideSection.title }}
                </SlpTypography>
                <SlpTypography tag="p" variant="body3" class="slp-mb-8">
                  {{ navItems[sectionIndex].primarySideSection.text }}
                </SlpTypography>
              </div>
              <SlpButton
                v-if="navItems[sectionIndex].primarySideSection.primaryLink"
                class="be-nav-mobile-menu__side-link be-nav-mobile-menu__side-link-small"
                variant="tertiary"
                :href="
                  navItems[sectionIndex].primarySideSection.primaryLink.href
                "
                v-bind="navItems[sectionIndex].primarySideSection.headerGa"
              >
                {{ navItems[sectionIndex].primarySideSection.primaryLink.text }}
                <SlpIcon
                  name="chevron-right"
                  variant="product"
                  alt="Chevron Right Icon"
                />
              </SlpButton>
            </a>
            <a
              class="be-nav-mobile-menu__bottom-section"
              :href="
                navItems[sectionIndex].secondarySideSection.primaryLink.href
              "
              v-bind="
                navItems[sectionIndex].secondarySideSection.primaryLink.headerGa
              "
            >
              <div>
                <div class="be-nav-mobile-menu__icon">
                  <PricingPlansIcon />
                </div>
                <SlpTypography tag="span" variant="body3-bold" class="slp-mb-8">
                  {{ navItems[sectionIndex].secondarySideSection.title }}
                </SlpTypography>
                <SlpTypography tag="p" variant="body3" class="slp-mb-8">
                  {{ navItems[sectionIndex].secondarySideSection.text }}
                </SlpTypography>
              </div>
              <SlpButton
                v-if="navItems[sectionIndex].secondarySideSection.primaryLink"
                class="be-nav-mobile-menu__side-link be-nav-mobile-menu__side-link-small slp-mb-8"
                variant="tertiary"
                :href="
                  navItems[sectionIndex].secondarySideSection.primaryLink.href
                "
                v-bind="
                  navItems[sectionIndex].secondarySideSection.primaryLink
                    .headerGa
                "
              >
                {{
                  navItems[sectionIndex].secondarySideSection.primaryLink.text
                }}
                <SlpIcon
                  name="chevron-right"
                  variant="product"
                  alt="Chevron Right Icon"
                />
              </SlpButton>
              <SlpButton
                v-if="navItems[sectionIndex].secondarySideSection.secondaryLink"
                class="be-nav-mobile-menu__side-link be-nav-mobile-menu__side-link-small slp-mb-16"
                variant="tertiary"
                :href="
                  navItems[sectionIndex].secondarySideSection.secondaryLink.href
                "
                v-bind="
                  navItems[sectionIndex].secondarySideSection.secondaryLink
                    .headerGa
                "
              >
                {{
                  navItems[sectionIndex].secondarySideSection.secondaryLink.text
                }}
                <SlpIcon
                  name="chevron-right"
                  variant="product"
                  alt="Chevron Right Icon"
                />
              </SlpButton>
            </a>
          </div>
        </div>
        <!-- Sign In Button -->
        <div
          v-if="sectionIndex && sectionIndex === -1"
          class="slp-flex slp-mt-16"
        >
          <SlpButton
            variant="ghost"
            class="be-nav-mobile-menu-item be-nav-mobile-menu-item--icon-btn"
            :name="navigationData.login.text"
            :href="navigationData.login.href"
            v-bind="navigationData.login.headerGa"
          >
            <div class="slp-flex slp-align-items-center">
              <SlpIcon
                name="user"
                variant="product"
                slp-color="primary-200"
                class="slp-mr-8"
              />
              <SlpTypography tag="span" variant="body1">
                {{ navigationData.login.text }}
              </SlpTypography>
            </div>
          </SlpButton>
        </div>
        <!-- Talk to an expert button -->
        <div
          v-if="sectionIndex && sectionIndex === -1 && !hideSalesButton"
          class="slp-flex"
        >
          <SlpButton
            :href="navigationData.sales.href"
            variant="ghost"
            class="be-nav-mobile-menu-item be-nav-mobile-menu-item--icon-btn"
            v-bind="navigationData.sales.headerGa"
          >
            <div class="slp-flex slp-align-items-center">
              <SlpIcon
                name="comment"
                variant="product"
                slp-color="primary-200"
                class="slp-mr-8"
              />
              <SlpTypography tag="span" variant="body1">
                {{ navigationData.sales.text }}
              </SlpTypography>
            </div>
          </SlpButton>
        </div>
      </div>
    </div>
    <!-- Free trial button -->
    <SlpButton
      v-show="!isDropdownOpen"
      :href="navigationData.freeTrial.href"
      variant="primary"
      class="be-nav-mobile-menu-bottom"
      v-bind="navigationData.freeTrial.headerGa"
      :name="navigationData.freeTrial.text"
    >
      {{ navigationData.freeTrial.text }}
    </SlpButton>
  </div>
</template>

<style lang="scss">
.be-nav-mobile-menu {
  *,
  ::before,
  ::after {
    box-sizing: border-box;
  }

  .w-100 {
    width: 100%;
  }

  position: fixed;
  background-color: $color-surface-50;
  top: 0;
  right: 0;
  left: 0;
  bottom: 0;
  display: flex;
  flex-direction: column;
  max-width: 100vw;
  overflow-x: hidden;

  &__login {
    display: flex;
    flex-direction: column;
    margin: $spacing-24 $spacing-16 0 $spacing-16;
    text-align: center;
  }

  &-top {
    &_back,
    &_logo {
      display: flex;
      align-items: center;
      justify-content: space-between;
      width: 100%;
      padding: 0 $spacing-8;
    }

    &_back {
      border-bottom: 1px solid $color-surface-300;
      margin: 0 $spacing-16;
      display: flex;
      padding: 0;

      &:deep(.slp-btn) {
        padding: $spacing-8 0;
      }
    }
  }

  &-bottom {
    display: flex;
    justify-content: center;
    margin: $spacing-8 $spacing-16;
  }

  &-item {
    width: 100%;
    border-radius: 0px !important;
    justify-content: space-between;
    border-bottom: 1px solid $color-surface-300 !important;
    padding: $spacing-8 0 !important;
    color: $color-primary-200;
    margin: 0 $spacing-16;
    display: flex;

    &--sub {
      margin-left: $spacing-32;
    }

    &--icon-btn {
      padding: $spacing-16 0 !important;
    }

    &__dropdown {
      background: $color-surface-100 !important;
    }

    a {
      color: $color-text-300;
    }

    span {
      text-align: start;
    }
  }

  &__bottom-section {
    display: flex;
    flex-direction: column;
    padding: $spacing-24;
    background-color: #2f2a6b;

    h5,
    p {
      color: $color-text-50;
      font-weight: 400 !important;
    }
  }

  &__image {
    max-width: 375px;
  }

  &__image,
  &__logo {
    margin-bottom: $spacing-16;
    width: 100%;
    display: flex;
    justify-content: center;

    img {
      width: 100%;
      height: 100%;
      object-fit: cover;
    }
  }

  &__logo {
    padding: 12px;
    box-sizing: border-box;

    img {
      object-fit: contain;
    }
  }

  &__icon {
    margin-bottom: $spacing-16;
    color: $color-text-300;
  }

  &__side-link {
    padding-left: 0 !important;
    padding-bottom: 0 !important;
    color: $color-surface-50 !important;

    &-small {
      font-size: 14px !important;
    }
  }

  // Explicitly set span color to fix iOS 15 safari bug
  span {
    color: $color-text-300;
  }

  .logos-container {
    width: 100%;
  }

  .logos {
    display: flex;
    align-items: center;
    justify-content: center;
    margin-top: $spacing-16;

    &_image {
      display: flex;
      align-items: center;
      justify-content: center;
      width: 64px;
      height: 64px;
    }

    svg {
      height: 100%;
      width: 100%;
    }
  }
  &:deep(.slp-color-accent-500) {
    color: #7759c2 !important;
  }
}
</style>
